' ########################################################################################
'                              Toolbar wrapper functions
' ########################################################################################

' ========================================================================================
' Adds one or more images to the list of button images available for a toolbar.
' Minimum operating systems Windows NT 3.51, Windows 95
' ========================================================================================
FUNCTION ToolBar_AddBitmap (BYVAL hToolBar AS DWORD, BYVAL nButtons AS LONG, BYREF tabm AS TBADDBITMAP) AS LONG
   FUNCTION = SendMessage (hToolBar, %TB_ADDBITMAP, 0, BYVAL VARPTR(tabm))
END FUNCTION
' ========================================================================================

' ========================================================================================
' Number of buttons to add.
' Minimum operating systems Windows NT 3.51, Windows 95
' ========================================================================================
FUNCTION ToolBar_AddButtons (BYVAL hToolBar AS DWORD, BYVAL uNumButtons AS DWORD, BYVAL lpButtons AS DWORD) AS LONG
   FUNCTION = SendMessage(hToolBar, %TB_ADDBUTTONS, uNumButtons, lpButtons)
END FUNCTION
' ========================================================================================

' ========================================================================================
' Adds a new string to the toolbar's string pool.
' Minimum operating systems Windows NT 3.51, Windows 95
' ========================================================================================
FUNCTION ToolBar_AddString (BYVAL hToolBar AS DWORD, BYVAL hinst AS DWORD, BYVAL idString AS LONG) AS LONG
   FUNCTION = SendMessage(hToolBar, %TB_ADDSTRING, hinst, IIF(hInst = %NULL, idString, MAKLNG(idString, 0)))
END FUNCTION
' ========================================================================================

' ========================================================================================
' Causes a toolbar to be resized.
' Minimum operating systems Windows NT 3.51, Windows 95
' ========================================================================================
SUB ToolBar_AutoSize (BYVAL hToolBar AS DWORD)
   SendMessage hToolBar, %TB_AUTOSIZE, 0, 0
END SUB
' ========================================================================================

' ========================================================================================
' Retrieves a count of the buttons currently in the toolbar.
' Minimum operating systems Windows NT 3.51, Windows 95
' ========================================================================================
FUNCTION ToolBar_ButtonCount (BYVAL hToolBar AS DWORD) AS LONG
   FUNCTION = SendMessage (hToolBar, %TB_BUTTONCOUNT, 0, 0)
END FUNCTION
' ========================================================================================

' ========================================================================================
' Specifies the size of the TBBUTTON structure.
' Minimum operating systems Windows NT 3.51, Windows 95
' ========================================================================================
SUB ToolBar_ButtonStructSize (BYVAL hToolBar AS DWORD, BYVAL cb AS LONG)
   SendMessage hToolBar, %TB_BUTTONSTRUCTSIZE, cb, 0
END SUB
' ========================================================================================

' ========================================================================================
' Changes the bitmap for a button in a toolbar.
' Minimum operating systems Windows NT 3.51, Windows 95
' ========================================================================================
FUNCTION ToolBar_ChangeBitmap (BYVAL hToolBar AS DWORD, BYVAL idButton AS LONG, BYVAL iBitmap AS WORD) AS LONG
   FUNCTION = SendMessage(hToolBar, %TB_CHANGEBITMAP, idButton, MAKDWD(iBitmap, 0))
END FUNCTION
' ========================================================================================

' ========================================================================================
' Checks or unchecks a given button in a toolbar.
' Minimum operating systems Windows NT 3.51, Windows 95
' ========================================================================================
FUNCTION ToolBar_CheckButton (BYVAL hToolBar AS DWORD, BYVAL idButton AS LONG, BYVAL fCheck AS INTEGER) AS LONG
   FUNCTION = SendMessage(hToolBar, %TB_CHECKBUTTON, idButton, MAKLNG(fCheck, 0))
END FUNCTION
' ========================================================================================

' ========================================================================================
' Retrieves the zero-based index for the button associated with the specified command
' identifier.
' Minimum operating systems Windows NT 3.51, Windows 95
' ========================================================================================
FUNCTION ToolBar_CommandToIndex (BYVAL hToolBar AS DWORD, BYVAL idButton AS LONG) AS LONG
   FUNCTION = SendMessage(hToolBar, %TB_COMMANDTOINDEX, idButton, 0)
END FUNCTION
' ========================================================================================

' ========================================================================================
' Displays the Customize Toolbar dialog box.
' Minimum operating systems Windows NT 3.51, Windows 95
' ========================================================================================
SUB ToolBar_Customize (BYVAL hToolBar AS DWORD)
   SendMessage hToolBar, %TB_CUSTOMIZE, 0, 0
END SUB
' ========================================================================================

' ========================================================================================
' Deletes a button from the toolbar.
' Minimum operating systems Windows NT 3.51, Windows 95
' ========================================================================================
FUNCTION ToolBar_DeleteButton (BYVAL hToolBar AS DWORD, BYVAL iButton AS LONG) AS LONG
   FUNCTION = SendMessage(hToolBar, %TB_DELETEBUTTON, iButton, 0)
END FUNCTION
' ========================================================================================

' ========================================================================================
' Enables or disables the specified button in a toolbar.
' Minimum operating systems Windows NT 3.51, Windows 95
' ========================================================================================
FUNCTION ToolBar_EnableButton (BYVAL hToolBar AS DWORD, BYVAL idButton AS LONG, BYVAL fEnable AS INTEGER) AS LONG
   FUNCTION = SendMessage(hToolBar, %TB_ENABLEBUTTON, idButton, MAKLNG(fEnable, 0))
END FUNCTION
' ========================================================================================

' ========================================================================================
' Retrieves the anchor highlight setting for a toolbar.
' Minimum operating systems Windows 2000, Windows NT 4.0 with Internet Explorer 4.0,
' Windows 98, Windows 95 with Internet Explorer 4.0
' ========================================================================================
FUNCTION ToolBar_GetAnchorHighlight (BYVAL hToolBar AS DWORD) AS LONG
   FUNCTION = SendMessage (hToolBar, %TB_GETANCHORHIGHLIGHT, 0, 0)
END FUNCTION
' ========================================================================================

' ========================================================================================
' Retrieves the index of the bitmap associated with a button in a toolbar.
' Minimum operating systems Windows NT 3.51, Windows 95
' ========================================================================================
FUNCTION ToolBar_GetBitmap (BYVAL hToolBar AS DWORD, BYVAL idButton AS LONG) AS LONG
   FUNCTION = SendMessage(hToolBar, %TB_GETBITMAP, idButton, 0)
END FUNCTION
' ========================================================================================

' ========================================================================================
' Retrieves the flags that describe the type of bitmap to be used.
' Minimum operating systems Windows NT 3.51, Windows 95
' ========================================================================================
FUNCTION ToolBar_GetBitmapFlags (BYVAL hToolBar AS DWORD) AS LONG
   FUNCTION = SendMessage(hToolBar, %TB_GETBITMAPFLAGS, 0, 0)
END FUNCTION
' ========================================================================================

' ========================================================================================
' Retrieves information about the specified button in a toolbar.
' Minimum operating systems Windows NT 3.51, Windows 95
' ========================================================================================
FUNCTION ToolBar_GetButton (BYVAL hToolBar AS DWORD, BYVAL iButton AS LONG, BYREF ptbb AS TBBUTTON) AS LONG
   FUNCTION = SendMessage(hToolBar, %TB_GETBUTTON, iButton, BYVAL VARPTR(ptbb))
END FUNCTION
' ========================================================================================

' ========================================================================================
' Retrieves the current height of toolbar buttons, in pixels.
' Minimum operating systems Windows 2000, Windows NT 4.0 with Internet Explorer 4.0,
' Windows 98, Windows 95 with Internet Explorer 4.0
' ========================================================================================
FUNCTION ToolBar_GetButtonHeight (BYVAL hToolBar AS DWORD) AS DWORD
   FUNCTION = HIWRD(SendMessage(hToolBar, %TB_GETBUTTONSIZE, 0, 0))
END FUNCTION
' ========================================================================================

' ========================================================================================
' Retrieves extended information for a button in a toolbar.
' Minimum operating systems Windows 2000, Windows NT 4.0 with Internet Explorer 4.0,
' Windows 98, Windows 95 with Internet Explorer 4.0
' ========================================================================================
FUNCTION ToolBar_GetButtonInfo (BYVAL hToolBar AS DWORD, BYVAL iID AS LONG, BYREF lptbbi AS TBBUTTONINFO) AS LONG
   FUNCTION = SendMessage(hToolBar, %TB_GETBUTTONINFO, iID, BYVAL VARPTR(lptbbi))
END FUNCTION
' ========================================================================================

' ========================================================================================
' Retrieves the current width and height of toolbar buttons, in pixels.
' Minimum operating systems Windows 2000, Windows NT 4.0 with Internet Explorer 4.0,
' Windows 98, Windows 95 with Internet Explorer 4.0
' ========================================================================================
FUNCTION ToolBar_GetButtonSize (BYVAL hToolBar AS DWORD) AS DWORD
   FUNCTION = SendMessage(hToolBar, %TB_GETBUTTONSIZE, 0, 0)
END FUNCTION
' ========================================================================================

' ========================================================================================
' Retrieves the display text of a button on a toolbar.
' Minimum operating systems Windows NT 3.51, Windows 95
' ========================================================================================
FUNCTION ToolBar_GetButtonText (BYVAL hToolBar AS DWORD, BYVAL idButton AS LONG) AS STRING
   LOCAL nLen AS LONG
   LOCAL buffer AS STRING
   nLen = SendMessage(hToolBar, %TB_GETBUTTONTEXT, idButton, 0)
   IF nLen < 1 THEN EXIT FUNCTION
   buffer = SPACE$(nLen + 1)
   nLen = SendMessage(hToolBar, %TB_GETBUTTONTEXT, idButton, STRPTR(buffer))
   IF nLen < 1 THEN EXIT FUNCTION
   FUNCTION = LEFT$(buffer, nLen)
END FUNCTION
' ========================================================================================

' ========================================================================================
' Retrieves the current width of toolbar buttons, in pixels.
' Minimum operating systems Windows 2000, Windows NT 4.0 with Internet Explorer 4.0,
' Windows 98, Windows 95 with Internet Explorer 4.0
' ========================================================================================
FUNCTION ToolBar_GetButtonWidth (BYVAL hToolBar AS DWORD) AS DWORD
   FUNCTION = LOWRD(SendMessage(hToolBar, %TB_GETBUTTONSIZE, 0, 0))
END FUNCTION
' ========================================================================================

' ========================================================================================
' Retrieves the color scheme information from the toolbar control.
' Minimum operating systems Windows 2000, Windows NT 4.0 with Internet Explorer 4.0,
' Windows 98, Windows 95 with Internet Explorer 4.0
' ========================================================================================
FUNCTION ToolBar_GetColorScheme (BYVAL hToolBar AS DWORD, BYREF lpcs AS COLORSCHEME) AS LONG
   FUNCTION = SendMessage(hToolBar, %TB_GETCOLORSCHEME, 0, BYVAL VARPTR(lpcs))
END FUNCTION
' ========================================================================================

' ========================================================================================
' Retrieves the image list that a toolbar control uses to display inactive buttons.
' Minimum operating systems Windows 2000, Windows NT 4.0 with Internet Explorer 4.0,
' Windows 98, Windows 95 with Internet Explorer 4.0
' ========================================================================================
FUNCTION ToolBar_GetDisabledImageList (BYVAL hToolBar AS DWORD) AS DWORD
   FUNCTION = SendMessage(hToolBar, %TB_GETDISABLEDIMAGELIST, 0, 0)
END FUNCTION
' ========================================================================================

' ========================================================================================
' Retrieves the extended styles for a toolbar control.
' Minimum operating systems Windows 2000, Windows NT 4.0 with Internet Explorer 4.0,
' Windows 98, Windows 95 with Internet Explorer 4.0
' ========================================================================================
FUNCTION ToolBar_GetExtendedStyle (BYVAL hToolBar AS DWORD) AS DWORD
   FUNCTION = SendMessage(hToolBar, %TB_GETEXTENDEDSTYLE, 0, 0)
END FUNCTION
' ========================================================================================

' ========================================================================================
' Retrieves the horizontal padding for a toolbar control.
' Minimum operating systems Windows 2000, Windows NT 4.0 with Internet Explorer 4.0,
' Windows 98, Windows 95 with Internet Explorer 4.0
' ========================================================================================
FUNCTION ToolBar_GetHorizontalPadding (BYVAL hToolBar AS DWORD) AS DWORD
   FUNCTION = LOWRD(SendMessage(hToolBar, %TB_GETPADDING, 0, 0))
END FUNCTION
' ========================================================================================

' ========================================================================================
' Retrieves the image list that a toolbar control uses to display hot buttons.
' Minimum operating systems Windows 2000, Windows NT 4.0 with Internet Explorer 4.0,
' Windows 98, Windows 95 with Internet Explorer 4.0
' ========================================================================================
FUNCTION ToolBar_GetHotImageList (BYVAL hToolBar AS DWORD) AS DWORD
   FUNCTION = SendMessage(hToolBar, %TB_GETHOTIMAGELIST, 0, 0)
END FUNCTION
' ========================================================================================

' ========================================================================================
' Retrieves the index of the hot item in a toolbar.
' Minimum operating systems Windows 2000, Windows NT 4.0 with Internet Explorer 4.0,
' Windows 98, Windows 95 with Internet Explorer 4.0
' ========================================================================================
FUNCTION ToolBar_GetHotItem (BYVAL hToolBar AS DWORD) AS LONG
   FUNCTION = SendMessage(hToolBar, %TB_GETHOTITEM, 0, 0)
END FUNCTION
' ========================================================================================

' ========================================================================================
' Retrieves the image list that a toolbar control uses to display buttons in their default
' state. A toolbar control uses this image list to display buttons when they are not hot
' or disabled.
' Minimum operating systems Windows 2000, Windows NT 4.0 with Internet Explorer 4.0,
' Windows 98, Windows 95 with Internet Explorer 4.0
' ========================================================================================
FUNCTION ToolBar_GetImageList (BYVAL hToolBar AS DWORD) AS DWORD
   FUNCTION = SendMessage(hToolBar, %TB_GETIMAGELIST, 0, 0)
END FUNCTION
' ========================================================================================

' ========================================================================================
' Retrieves the current insertion mark for the toolbar.
' Minimum operating systems Windows 2000, Windows NT 4.0 with Internet Explorer 4.0,
' Windows 98, Windows 95 with Internet Explorer 4.0
' ========================================================================================
FUNCTION ToolBar_GetInsertMark (BYVAL hToolBar AS DWORD, BYREF ptbim AS TBINSERTMARK) AS LONG
   FUNCTION = SendMessage(hToolBar, %TB_GETINSERTMARK, 0, BYVAL VARPTR(ptbim))
END FUNCTION
' ========================================================================================

' ========================================================================================
' Retrieves the color used to draw the insertion mark for the toolbar.
' Minimum operating systems Windows 2000, Windows NT 4.0 with Internet Explorer 4.0,
' Windows 98, Windows 95 with Internet Explorer 4.0
' ========================================================================================
FUNCTION ToolBar_GetInsertMarkColor (BYVAL hToolBar AS DWORD) AS LONG
   FUNCTION = SendMessage(hToolBar, %TB_GETINSERTMARKCOLOR, 0, 0)
END FUNCTION
' ========================================================================================

' ========================================================================================
' Retrieves the bounding rectangle of a button in a toolbar.
' Minimum operating systems Windows NT 3.51, Windows 95
' ========================================================================================
FUNCTION ToolBar_GetItemRect (BYVAL hToolBar AS DWORD, BYVAL iButton AS LONG, BYREF lprc AS RECT) AS LONG
   FUNCTION = SendMessage(hToolBar, %TB_GETITEMRECT, iButton, BYVAL VARPTR(lprc))
END FUNCTION
' ========================================================================================

' ========================================================================================
' Retrieves the total size of all of the visible buttons and separators in the toolbar.
' Minimum operating systems Windows 2000, Windows NT 4.0 with Internet Explorer 4.0,
' Windows 98, Windows 95 with Internet Explorer 4.0
' ========================================================================================
FUNCTION ToolBar_GetMaxSize (BYVAL hToolBar AS DWORD, BYREF psize AS APISIZE) AS LONG
   FUNCTION = SendMessage(hToolBar, %TB_GETMAXSIZE, 0, BYVAL VARPTR(psize))
END FUNCTION
' ========================================================================================

' ========================================================================================
' Retrieves the metrics of a toolbar control.
' Note  To use this API, you must provide a manifest specifying Comclt32.dll version 6.0.
' ========================================================================================
SUB ToolBar_GetMetrics (BYVAL hToolBar AS DWORD, BYREF ptbMetrics AS TBMETRICS)
   SendMessage hToolBar, %TB_GETMETRICS, 0, BYVAL VARPTR(ptbMetrics)
END SUB
' ========================================================================================

' ========================================================================================
' Retrieves the IDropTarget for a toolbar control.
' Minimum operating systems Windows 2000, Windows NT 4.0 with Internet Explorer 4.0,
' Windows 98, Windows 95 with Internet Explorer 4.0
' ========================================================================================
FUNCTION ToolBar_GetObject (BYVAL hToolBar AS DWORD, BYVAL ppvObject AS DWORD PTR) AS LONG
   LOCAL IID_IDropTarget AS GUID
   IID_IDropTarget = GUID$("{00000122-0000-0000-C000-000000000046}")
   FUNCTION = SendMessage(hToolBar, %TB_GETOBJECT, BYVAL VARPTR(IID_IDropTarget), ppvObject)
END FUNCTION
' ========================================================================================

' ========================================================================================
' Retrieves the padding for a toolbar control.
' Minimum operating systems Windows 2000, Windows NT 4.0 with Internet Explorer 4.0,
' Windows 98, Windows 95 with Internet Explorer 4.0
' ========================================================================================
FUNCTION ToolBar_GetPadding (BYVAL hToolBar AS DWORD) AS DWORD
   FUNCTION = SendMessage(hToolBar, %TB_GETPADDING, 0, 0)
END FUNCTION
' ========================================================================================

' ========================================================================================
' Retrieves the bounding rectangle for a specified toolbar button.
' Minimum operating systems Windows 2000, Windows NT 4.0 with Internet Explorer 4.0,
' Windows 98, Windows 95 with Internet Explorer 4.0
' ========================================================================================
FUNCTION ToolBar_GetRect (BYVAL hToolBar AS DWORD, BYVAL iID AS LONG, BYREF lprc AS RECT) AS LONG
   FUNCTION = SendMessage(hToolBar, %TB_GETRECT, iID, BYVAL VARPTR(lprc))
END FUNCTION
' ========================================================================================

' ========================================================================================
' Retrieves the number of rows of buttons in a toolbar with the TBSTYLE_WRAPABLE style.
' Minimum operating systems Windows NT 3.51, Windows 95
' ========================================================================================
FUNCTION ToolBar_GetRows (BYVAL hToolBar AS DWORD) AS DWORD
   FUNCTION = SendMessage(hToolBar, %TB_GETROWS, 0, 0)
END FUNCTION
' ========================================================================================

' ========================================================================================
' Retrieves information about the state of the specified button in a toolbar, such as
' whether it is enabled, pressed, or checked.
' Minimum operating systems Windows NT 3.51, Windows 95
' ========================================================================================
FUNCTION ToolBar_GetState (BYVAL hToolBar AS DWORD, BYVAL idButton AS LONG) AS LONG
   FUNCTION = SendMessage(hToolBar, %TB_GETSTATE, idButton, 0)
END FUNCTION
' ========================================================================================

' ========================================================================================
' Retrieves a string from a toolbar's string pool.
' Minimum operating systems Windows 2000, Windows NT 4.0 with Internet Explorer 4.0,
' Windows 98, Windows 95 with Internet Explorer 4.0
' ========================================================================================
FUNCTION ToolBar_GetString (BYVAL hToolBar AS DWORD, BYVAL iString AS INTEGER, OPTIONAL BYVAL cchMax AS INTEGER) AS STRING
   LOCAL nLen AS LONG
   LOCAL buffer AS STRING
   IF cchMax < 1 THEN cchMax = 255
   buffer = SPACE$(cchMax + 1)
   nLen = SendMessage(hToolBar, %TB_GETSTRING, MAKDWD(cchMax, iString), STRPTR(buffer))
   IF nLen < 1 THEN EXIT FUNCTION
   FUNCTION = LEFT$(buffer, nLen)
END FUNCTION
' ========================================================================================

' ========================================================================================
' Retrieves the styles currently in use for a toolbar control.
' Minimum operating systems Windows 2000, Windows NT 4.0 with Internet Explorer 4.0,
' Windows 98, Windows 95 with Internet Explorer 4.0
' ========================================================================================
FUNCTION ToolBar_GetStyle (BYVAL hToolBar AS DWORD) AS DWORD
   FUNCTION = SendMessage(hToolBar, %TB_GETSTYLE, 0, 0)
END FUNCTION
' ========================================================================================

' ========================================================================================
' Retrieves the maximum number of text rows that can be displayed on a toolbar button.
' Minimum operating systems Windows 2000, Windows NT 4.0 with Internet Explorer 4.0,
' Windows 98, Windows 95 with Internet Explorer 4.0
' ========================================================================================
FUNCTION ToolBar_GetTextRows (BYVAL hToolBar AS DWORD) AS DWORD
   FUNCTION = SendMessage(hToolBar, %TB_GETTEXTROWS, 0, 0)
END FUNCTION
' ========================================================================================

' ========================================================================================
' Retrieves the handle to the ToolTip control, if any, associated with the toolbar.
' Minimum operating systems Windows NT 3.51, Windows 95
' ========================================================================================
FUNCTION ToolBar_GetTooltips (BYVAL hToolBar AS DWORD) AS DWORD
   FUNCTION = SendMessage(hToolBar, %TB_GETTOOLTIPS, 0, 0)
END FUNCTION
' ========================================================================================

' ========================================================================================
' Retrieves the Unicode character format flag for the control.
' Minimum operating systems: Windows NT 4.0, Windows 95
' ========================================================================================
FUNCTION ToolBar_GetUnicodeFormat (BYVAL hToolBar AS DWORD) AS DWORD
   FUNCTION = SendMessage(hToolBar, %TB_GETUNICODEFORMAT, 0, 0)
END FUNCTION
' ========================================================================================

' ========================================================================================
' Retrieves the vertical padding for a toolbar control.
' Minimum operating systems Windows 2000, Windows NT 4.0 with Internet Explorer 4.0,
' Windows 98, Windows 95 with Internet Explorer 4.0
' ========================================================================================
FUNCTION ToolBar_GetVerticalPadding (BYVAL hToolBar AS DWORD) AS DWORD
   FUNCTION = HIWRD(SendMessage(hToolBar, %TB_GETPADDING, 0, 0))
END FUNCTION
' ========================================================================================

' ========================================================================================
' Hides or shows the specified button in a toolbar.
' Minimum operating systems Windows NT 3.51, Windows 95
' ========================================================================================
FUNCTION ToolBar_HideButton (BYVAL hToolBar AS DWORD, BYVAL idButton AS LONG, BYVAL fShow AS INTEGER) AS LONG
   FUNCTION = SendMessage(hToolBar, %TB_HIDEBUTTON, idButton, MAKLNG(fShow, 0))
END FUNCTION
' ========================================================================================

' ========================================================================================
' Determines where a point lies in a toolbar control.
' Minimum operating systems: Windows NT 4.0, Windows 95
' ========================================================================================
FUNCTION ToolBar_HitTest (BYVAL hToolBar AS DWORD, BYREF pptHitTest AS POINTAPI) AS LONG
   FUNCTION = SendMessage(hToolBar, %TB_HITTEST, 0, BYVAL VARPTR(pptHitTest))
END FUNCTION
' ========================================================================================

' ========================================================================================
' Sets or clears the indeterminate state of the specified button in a toolbar.
' Minimum operating systems Windows NT 3.51, Windows 95
' ========================================================================================
FUNCTION ToolBar_Indeterminate (BYVAL hToolBar AS DWORD, BYVAL idButton AS LONG, BYVAL fIndeterminate AS INTEGER) AS LONG
   FUNCTION = SendMessage(hToolBar, %TB_INDETERMINATE, idButton, MAKLNG(fIndeterminate, 0))
END FUNCTION
' ========================================================================================

' ========================================================================================
' Inserts a button in a toolbar.
' Minimum operating systems Windows NT 3.51, Windows 95
' ========================================================================================
FUNCTION ToolBar_InsertButton (BYVAL hToolBar AS DWORD, BYVAL iButton AS LONG, BYREF lpButton AS TBBUTTON) AS LONG
   FUNCTION = SendMessage(hToolBar, %TB_INSERTBUTTON, iButton, BYVAL VARPTR(lpButton))
END FUNCTION
' ========================================================================================

' ========================================================================================
' Retrieves the insertion mark information for a point in a toolbar.
' Minimum operating systems Windows 2000, Windows NT 4.0 with Internet Explorer 4.0,
' Windows 98, Windows 95 with Internet Explorer 4.0
' ========================================================================================
FUNCTION ToolBar_InsertMarkHitTest (BYVAL hToolBar AS DWORD, BYREF lppt AS POINTAPI, BYREF lptbim AS TBINSERTMARK) AS LONG
   FUNCTION = SendMessage(hToolBar, %TB_INSERTMARKHITTEST, BYVAL VARPTR(lppt), BYVAL VARPTR(lptbim))
END FUNCTION
' ========================================================================================

' ========================================================================================
' Determines whether the specified button in a toolbar is checked.
' Minimum operating systems Windows NT 3.51, Windows 95
' ========================================================================================
FUNCTION ToolBar_IsButtonChecked (BYVAL hToolBar AS DWORD, BYVAL idButton AS LONG) AS LONG
   FUNCTION = SendMessage(hToolBar, %TB_ISBUTTONCHECKED, idButton, 0)
END FUNCTION
' ========================================================================================

' ========================================================================================
' Determines whether the specified button in a toolbar is enabled.
' Minimum operating systems Windows NT 3.51, Windows 95
' ========================================================================================
FUNCTION ToolBar_IsButtonEnabled (BYVAL hToolBar AS DWORD, BYVAL idButton AS LONG) AS LONG
   FUNCTION = SendMessage(hToolBar, %TB_ISBUTTONENABLED, idButton, 0)
END FUNCTION
' ========================================================================================

' ========================================================================================
' Determines whether the specified button in a toolbar is hidden.
' Minimum operating systems Windows NT 3.51, Windows 95
' ========================================================================================
FUNCTION ToolBar_IsButtonHidden (BYVAL hToolBar AS DWORD, BYVAL idButton AS LONG) AS LONG
   FUNCTION = SendMessage(hToolBar, %TB_ISBUTTONHIDDEN, idButton, 0)
END FUNCTION
' ========================================================================================

' ========================================================================================
' Checks the highlight state of a toolbar button.
' Minimum operating systems Windows 2000, Windows NT 4.0 with Internet Explorer 4.0,
' Windows 98, Windows 95 with Internet Explorer 4.0
' ========================================================================================
FUNCTION ToolBar_IsButtonHighlighted (BYVAL hToolBar AS DWORD, BYVAL idButton AS LONG) AS LONG
   FUNCTION = SendMessage(hToolBar, %TB_ISBUTTONHIGHLIGHTED, idButton, 0)
END FUNCTION
' ========================================================================================

' ========================================================================================
' Determines whether the specified button in a toolbar is indeterminate.
' Minimum operating systems Windows NT 3.51, Windows 95
' ========================================================================================
FUNCTION ToolBar_IsButtonIndeterminate (BYVAL hToolBar AS DWORD, BYVAL idButton AS LONG) AS LONG
   FUNCTION = SendMessage(hToolBar, %TB_ISBUTTONINDETERMINATE, idButton, 0)
END FUNCTION
' ========================================================================================

' ========================================================================================
' Determines whether the specified button in a toolbar is pressed.
' Minimum operating systems Windows NT 3.51, Windows 95
' ========================================================================================
FUNCTION ToolBar_IsButtonPressed (BYVAL hToolBar AS DWORD, BYVAL idButton AS LONG) AS LONG
   FUNCTION = SendMessage(hToolBar, %TB_ISBUTTONPRESSED, idButton, 0)
END FUNCTION
' ========================================================================================

' ========================================================================================
' Loads system-defined button images into a toolbar control's image list.
' Minimum operating systems Windows 2000, Windows NT 4.0 with Internet Explorer 4.0,
' Windows 98, Windows 95 with Internet Explorer 4.0
' ========================================================================================
FUNCTION ToolBar_LoadImages (BYVAL hToolBar AS DWORD, BYVAL iBitmapID AS DWORD, BYVAL hinst AS DWORD) AS LONG
   FUNCTION = SendMessage(hToolBar, %TB_LOADIMAGES, iBitmapID, hinst)
END FUNCTION
' ========================================================================================

' ========================================================================================
' Determines the ID of the button that corresponds to the specified accelerator character.
' Minimum operating systems Windows 2000, Windows NT 4.0 with Internet Explorer 4.0,
' Windows 98, Windows 95 with Internet Explorer 4.0
' ========================================================================================
FUNCTION ToolBar_MapAccelerator (BYVAL hToolBar AS DWORD, BYVAL chAccel AS DWORD, BYREF pIDBtn AS DWORD) AS LONG
   FUNCTION = SendMessage(hToolBar, %TB_MAPACCELERATOR, chAccel, BYVAL VARPTR(pIDBtn))
END FUNCTION
' ========================================================================================

' ========================================================================================
' Sets the highlight state of a given button in a toolbar control.
' Minimum operating systems Windows 2000, Windows NT 4.0 with Internet Explorer 4.0,
' Windows 98, Windows 95 with Internet Explorer 4.0
' ========================================================================================
FUNCTION ToolBar_MarkButton (BYVAL hToolBar AS DWORD, BYVAL idButton AS LONG, BYVAL fHighlight AS INTEGER) AS LONG
   FUNCTION = SendMessage(hToolBar, %TB_MARKBUTTON, idButton, MAKLNG(fHighlight, 0))
END FUNCTION
' ========================================================================================

' ========================================================================================
' Moves a button from one index to another.
' Minimum operating systems Windows 2000, Windows NT 4.0 with Internet Explorer 4.0,
' Windows 98, Windows 95 with Internet Explorer 4.0
' ========================================================================================
FUNCTION ToolBar_MoveButton (BYVAL hToolBar AS DWORD, BYVAL uOldPos AS DWORD, BYVAL uNewPos AS DWORD) AS LONG
   FUNCTION = SendMessage(hToolBar, %TB_MOVEBUTTON, uOldPos, uNewPos)
END FUNCTION
' ========================================================================================

' ========================================================================================
' Presses or releases the specified button in a toolbar.
' Minimum operating systems Windows NT 3.51, Windows 95
' ========================================================================================
FUNCTION ToolBar_PressButton (BYVAL hToolBar AS DWORD, BYVAL idButton AS LONG, BYVAL fPress AS INTEGER) AS LONG
   FUNCTION = SendMessage(hToolBar, %TB_PRESSBUTTON, idButton, MAKLNG(fPress, 0))
END FUNCTION
' ========================================================================================

' ========================================================================================
' Replaces an existing bitmap with a new bitmap.
' Minimum operating systems Windows NT 4.0, Windows 95
' ========================================================================================
FUNCTION ToolBar_ReplaceBitmap (BYVAL hToolBar AS DWORD, BYREF ptbrb AS TBREPLACEBITMAP) AS LONG
   FUNCTION = SendMessage(hToolBar, %TB_REPLACEBITMAP, 0, BYVAL VARPTR(ptbrb))
END FUNCTION
' ========================================================================================

' ========================================================================================
' Send this message to initiate saving or restoring a toolbar state.
' Minimum operating systems Windows NT 3.51, Windows 95
' ========================================================================================
SUB ToolBar_SaveRestore (BYVAL hToolBar AS DWORD, BYVAL fSave AS LONG, BYREF ptbsp AS TBSAVEPARAMS)
   SendMessage hToolBar, %TB_SAVERESTORE, fSave, BYVAL VARPTR(ptbsp)
END SUB
' ========================================================================================

' ========================================================================================
' Sets the anchor highlight setting for a toolbar.
' Minimum operating systems Windows 2000, Windows NT 4.0 with Internet Explorer 4.0,
' Windows 98, Windows 95 with Internet Explorer 4.0
' ========================================================================================
FUNCTION ToolBar_SetAnchorHighlight (BYVAL hToolBar AS DWORD, BYVAL fAnchor AS LONG) AS LONG
   FUNCTION = SendMessage(hToolBar, %TB_SETANCHORHIGHLIGHT, fAnchor, 0)
END FUNCTION
' ========================================================================================

' ========================================================================================
' Sets the size of the bitmapped images to be added to a toolbar.
' Minimum operating systems Windows NT 3.51, Windows 95
' ========================================================================================
FUNCTION ToolBar_SetBitmapSize (BYVAL hToolBar AS DWORD, BYVAL dxBitmap AS INTEGER, BYVAL dyBitmap AS INTEGER) AS LONG
   FUNCTION = SendMessage(hToolBar, %TB_SETBITMAPSIZE, 0, MAKLNG(dxBitmap, dyBitmap))
END FUNCTION
' ========================================================================================

' ========================================================================================
' Sets the information for an existing button in a toolbar.
' Minimum operating systems Windows 2000, Windows NT 4.0 with Internet Explorer 4.0,
' Windows 98, Windows 95 with Internet Explorer 4.0
' ========================================================================================
FUNCTION ToolBar_SetButtonInfo (BYVAL hToolBar AS DWORD, BYVAL iID AS LONG, BYREF lptbbi AS TBBUTTONINFO) AS LONG
   FUNCTION = SendMessage(hToolBar, %TB_SETBUTTONINFO, iID, BYVAL VARPTR(lptbbi))
END FUNCTION
' ========================================================================================

' ========================================================================================
' Sets the size of the buttons to be added to a toolbar.
' Minimum operating systems Windows NT 3.51, Windows 95
' ========================================================================================
FUNCTION ToolBar_SetButtonSize (BYVAL hToolBar AS DWORD, BYVAL dxButton AS INTEGER, BYVAL dyButton AS INTEGER) AS LONG
   FUNCTION = SendMessage(hToolBar, %TB_SETBUTTONSIZE, 0, MAKLNG(dxButton, dyButton))
END FUNCTION
' ========================================================================================

' ========================================================================================
' Sets the minimum and maximum button widths in the toolbar control.
' Minimum operating systems Windows 2000, Windows NT 4.0 with Internet Explorer 4.0,
' Windows 98, Windows 95 with Internet Explorer 4.0
' ========================================================================================
FUNCTION ToolBar_SetButtonWidth (BYVAL hToolBar AS DWORD, BYVAL cxMin AS INTEGER, BYVAL cxMax AS INTEGER) AS LONG
   FUNCTION = SendMessage(hToolBar, %TB_SETBUTTONWIDTH, 0, MAKLNG(cxMin, cxMax))
END FUNCTION
' ========================================================================================

' ========================================================================================
' Sets the command identifier of a toolbar button.
' Minimum operating systems Windows NT 3.51, Windows 95
' ========================================================================================
FUNCTION ToolBar_SetCmdId (BYVAL hToolBar AS DWORD, BYVAL index AS INTEGER, BYVAL cmdid AS INTEGER) AS LONG
   FUNCTION = SendMessage(hToolBar, %TB_SETCMDID, index, cmdid)
END FUNCTION
' ========================================================================================

' ========================================================================================
' Sets the color scheme information for the toolbar control.
' Minimum operating systems Windows 2000, Windows NT 4.0 with Internet Explorer 4.0,
' Windows 98, Windows 95 with Internet Explorer 4.0
' ========================================================================================
SUB ToolBar_SetColorScheme (BYVAL hToolBar AS DWORD, BYREF lpcs AS COLORSCHEME)
   SendMessage hToolBar, %TB_SETCOLORSCHEME, 0, BYVAL VARPTR(lpcs)
END SUB
' ========================================================================================

' ========================================================================================
' Sets the image list that the toolbar control will use to display disabled buttons.
' Minimum operating systems Windows 2000, Windows NT 4.0 with Internet Explorer 4.0,
' Windows 98, Windows 95 with Internet Explorer 4.0
' ========================================================================================
FUNCTION ToolBar_SetDisabledImageList (BYVAL hToolBar AS DWORD, BYVAL himlNewDisabled AS DWORD) AS DWORD
   FUNCTION = SendMessage(hToolBar, %TB_SETDISABLEDIMAGELIST, 0, himlNewDisabled)
END FUNCTION
' ========================================================================================

' ========================================================================================
' Sets the text drawing flags for the toolbar.
' Minimum operating systems Windows 2000, Windows NT 4.0 with Internet Explorer 4.0,
' Windows 98, Windows 95 with Internet Explorer 4.0
' ========================================================================================
FUNCTION ToolBar_SetDrawTextFlags (BYVAL hToolBar AS DWORD, BYVAL dwMask AS LONG, BYVAL dwDTFlags AS LONG) AS LONG
   FUNCTION = SendMessage(hToolBar, %TB_SETDRAWTEXTFLAGS, dwMask, dwDTFlags)
END FUNCTION
' ========================================================================================

' ========================================================================================
' Sets the extended styles for a toolbar control.
' Minimum operating systems Windows 2000, Windows NT 4.0 with Internet Explorer 4.0,
' Windows 98, Windows 95 with Internet Explorer 4.0
' ========================================================================================
FUNCTION ToolBar_SetExtendedStyle (BYVAL hToolBar AS DWORD, BYVAL dwExStyle AS DWORD) AS DWORD
   FUNCTION = SendMessage(hToolBar, %TB_SETEXTENDEDSTYLE, 0, dwExStyle)
END FUNCTION
' ========================================================================================

' ========================================================================================
' Sets the image list that the toolbar control will use to display hot buttons.
' Minimum operating systems Windows 2000, Windows NT 4.0 with Internet Explorer 4.0,
' Windows 98, Windows 95 with Internet Explorer 4.0
' ========================================================================================
FUNCTION ToolBar_SetHotImageList (BYVAL hToolBar AS DWORD, BYVAL himlNewHot AS DWORD) AS DWORD
   FUNCTION = SendMessage(hToolBar, %TB_SETEXTENDEDSTYLE, 0, himlNewHot)
END FUNCTION
' ========================================================================================

' ========================================================================================
' Sets the image list that the toolbar control will use to display hot buttons.
' Minimum operating systems Windows 2000, Windows NT 4.0 with Internet Explorer 4.0,
' Windows 98, Windows 95 with Internet Explorer 4.0
' ========================================================================================
FUNCTION ToolBar_SetHotItem (BYVAL hToolBar AS DWORD, BYVAL iHot AS LONG) AS LONG
   FUNCTION = SendMessage(hToolBar, %TB_SETEXTENDEDSTYLE, iHot, 0)
END FUNCTION
' ========================================================================================

' ========================================================================================
' Sets the image list that the toolbar will use to display buttons that are in their
' default state.
' Minimum operating systems Windows 2000, Windows NT 4.0 with Internet Explorer 4.0,
' Windows 98, Windows 95 with Internet Explorer 4.0
' ========================================================================================
FUNCTION ToolBar_SetImageList (BYVAL hToolBar AS DWORD, BYVAL iImageID AS LONG, BYVAL himlNew AS DWORD) AS DWORD
   FUNCTION = SendMessage(hToolBar, %TB_SETIMAGELIST, iImageID, himlNew)
END FUNCTION
' ========================================================================================

' ========================================================================================
' Sets the indentation for the first button in a toolbar control.
' Minimum operating systems Windows 2000, Windows NT 4.0 with Internet Explorer 4.0,
' Windows 98, Windows 95 with Internet Explorer 4.0
' ========================================================================================
FUNCTION ToolBar_SetIndent (BYVAL hToolBar AS DWORD, BYVAL iIndent AS LONG) AS LONG
   FUNCTION = SendMessage(hToolBar, %TB_SETINDENT, iIndent, 0)
END FUNCTION
' ========================================================================================

' ========================================================================================
' Sets the current insertion mark for the toolbar.
' Minimum operating systems Windows 2000, Windows NT 4.0 with Internet Explorer 4.0,
' Windows 98, Windows 95 with Internet Explorer 4.0
' ========================================================================================
SUB ToolBar_SetInsertMark (BYVAL hToolBar AS DWORD, BYREF lptbim AS TBINSERTMARK)
   SendMessage hToolBar, %TB_SETINSERTMARK, 0, BYVAL VARPTR(lptbim)
END SUB
' ========================================================================================

' ========================================================================================
' Sets the color used to draw the insertion mark for the toolbar.
' Minimum operating systems Windows 2000, Windows NT 4.0 with Internet Explorer 4.0,
' Windows 98, Windows 95 with Internet Explorer 4.0
' ========================================================================================
FUNCTION ToolBar_SetInsertMarkColor (BYVAL hToolBar AS DWORD, BYVAL clrInsertMark AS LONG) AS LONG
   FUNCTION = SendMessage(hToolBar, %TB_SETINSERTMARKCOLOR, clrInsertMark, 0)
END FUNCTION
' ========================================================================================

' ========================================================================================
' Sets the maximum number of text rows displayed on a toolbar button.
' Minimum operating systems Windows 2000, Windows NT 4.0 with Internet Explorer 4.0,
' Windows 98, Windows 95 with Internet Explorer 4.0
' ========================================================================================
FUNCTION ToolBar_SetMaxTextRows (BYVAL hToolBar AS DWORD, BYVAL iMaxRows AS LONG) AS LONG
   FUNCTION = SendMessage(hToolBar, %TB_SETMAXTEXTROWS, iMaxRows, 0)
END FUNCTION
' ========================================================================================

' ========================================================================================
' Sets the metrics of a toolbar control.
' Minimum operating systems: Windows XP
' ========================================================================================
SUB ToolBar_SetMetrics (BYVAL hToolBar AS DWORD, BYREF ptbMetrics AS TBMETRICS)
   SendMessage hToolBar, %TB_SETMETRICS, 0, BYVAL VARPTR(ptbmetrics)
END SUB
' ========================================================================================

' ========================================================================================
' Sets the padding for a toolbar control.
' Minimum operating systems Windows 2000, Windows NT 4.0 with Internet Explorer 4.0,
' Windows 98, Windows 95 with Internet Explorer 4.0
' ========================================================================================
FUNCTION ToolBar_SetPadding (BYVAL hToolbar AS DWORD, BYVAL cx AS INTEGER, BYVAL cy AS INTEGER) AS DWORD
   FUNCTION = SendMessage(hToolBar, %TB_SETPADDING, 0, MAKDWD(cx, cy))
END FUNCTION
' ========================================================================================

' ========================================================================================
' Sets the window to which the toolbar control sends notification messages.
' Minimum operating systems: Windows NT 3.51, Windows 95.
' ========================================================================================
FUNCTION ToolBar_SetParent (BYVAL hToolBar AS DWORD, BYVAL hwndParent AS DWORD) AS DWORD
   FUNCTION = SendMessage(hToolBar, %TB_SETPARENT, hwndParent, 0)
END FUNCTION
' ========================================================================================

' ========================================================================================
' Sets the number of rows of buttons in a toolbar.
' Minimum operating systems: Windows NT 3.51, Windows 95.
' ========================================================================================
SUB ToolBar_SetRows (BYVAL hToolBar AS DWORD, BYVAL cRows AS WORD, BYVAL fLarger AS INTEGER, BYREF lprc AS RECT)
   SendMessage hToolBar, %TB_SETROWS, MAKDWD(cRows, fLarger), BYVAL VARPTR(lprc)
END SUB
' ========================================================================================

' ========================================================================================
' Sets the state for the specified button in a toolbar.
' Minimum operating systems: Windows NT 3.51, Windows 95.
' ========================================================================================
FUNCTION ToolBar_SetState (BYVAL hToolBar AS DWORD, BYVAL idButton AS LONG, BYVAL fState AS INTEGER) AS LONG
   FUNCTION = SendMessage(hToolBar, %TB_SETSTATE, idButton, MAKLNG(fState, 0))
END FUNCTION
' ========================================================================================

' ========================================================================================
' Sets the style for a toolbar control.
' Minimum operating systems Windows 2000, Windows NT 4.0 with Internet Explorer 4.0,
' Windows 98, Windows 95 with Internet Explorer 4.0
' ========================================================================================
SUB ToolBar_SetStyle (BYVAL hToolBar AS DWORD, BYVAL dwStyle AS DWORD)
   SendMessage hToolBar, %TB_SETSTYLE, 0, dwStyle
END SUB
' ========================================================================================

' ========================================================================================
' Associates a ToolTip control with a toolbar.
' Minimum operating systems: Windows NT 3.51, Windows 95.
' ========================================================================================
SUB ToolBar_SetToolTips (BYVAL hToolBar AS DWORD, BYVAL hwndToolTip AS DWORD)
   SendMessage hToolBar, %TB_SETTOOLTIPS, hwndToolTip, 0
END SUB
' ========================================================================================

' ========================================================================================
' Sets the Unicode character format flag for the control. This message allows you to
' change the character set used by the control at run time rather than having to re-create
' the control.
' Minimum operating systems: Windows NT 4.0, Windows 95.
' ========================================================================================
FUNCTION ToolBar_SetUnicodeFormat (BYVAL hToolBar AS DWORD, BYVAL fUnicode AS DWORD) AS DWORD
   FUNCTION = SendMessage(hToolBar, %TB_SETUNICODEFORMAT, fUnicode, 0)
END FUNCTION
' ========================================================================================

' ========================================================================================
' Sets the visual style of a toolbar control.
' Note  To use this API, you must provide a manifest specifying Comclt32.dll version 6.0.
' Minimum Operating System: Windows XP.
' ========================================================================================
SUB ToolBar_SetWindowTheme (BYVAL hToolBar AS DWORD, BYVAL pwStr AS STRING)
   pwStr = UCODE$(pwStr) & CHR$(0, 0)
   SendMessage hToolBar, %TB_SETWINDOWTHEME, STRPTR(pwStr), 0
END SUB
' ========================================================================================
